Index: branches/2016/dev_r6999_CONFIGMAN_1/NEMOGCM/TOOLS/SIREN/src/create_meshmask.f90
===================================================================
--- branches/2016/dev_r6999_CONFIGMAN_1/NEMOGCM/TOOLS/SIREN/src/create_meshmask.f90	(revision 7148)
+++ branches/2016/dev_r6999_CONFIGMAN_1/NEMOGCM/TOOLS/SIREN/src/create_meshmask.f90	(revision 7153)
@@ -1398,83 +1500,84 @@
          END DO
       END DO
-
-      IF( td_nam%c_cfg == "orca" .AND. td_nam%i_cfg == 2 )THEN   ! ORCA_R2 configuration
-         !                                                 ! Increased lateral friction near of some straits
-         IF( td_nam%i_cla == 0 ) THEN
-            ! Gibraltar strait  : partial slip (fmask=0.5)
-            ij0 = 101   ;   ij1 = 101
-            ii0 = 139   ;   ii1 = 140   
-            tg_fmask%d_value(ii0:ii1,ij0:ij1,1:jpk,1) =  0.5_dp
-
-            ij0 = 102   ;   ij1 = 102
-            ii0 = 139   ;   ii1 = 140
-            tg_fmask%d_value(ii0:ii1,ij0:ij1,1:jpk,1) =  0.5_dp
-            !
-            !Bab el Mandeb : partial slip (fmask=1)
-            ij0 =  87   ;   ij1 =  88
-            ii0 = 160   ;   ii1 = 160
-            tg_fmask%d_value(ii0:ii1,ij0:ij1,1:jpk,1) =  1._dp
-
-            ij0 =  88   ;   ij1 =  88
-            ii0 = 159   ;   ii1 = 159
-            tg_fmask%d_value(ii0:ii1,ij0:ij1,1:jpk,1) =  1._dp
-            !
-         ENDIF
-      ENDIF
-      !
-      IF( td_nam%c_cfg == "orca" .AND. td_nam%i_cfg == 1 )THEN   ! ORCA R1 configuration
-         ! Increased lateral friction near of some straits
-         ! This dirty section will be suppressed by simplification process:
-         ! all this will come back in input files
-         ! Currently these hard-wired indices relate to configuration with
-         ! extend grid (jpjglo=332)
-         !
-         isrow = 332 - jpj
-         ! Gibraltar Strait
-         ii0 = 282           ;   ii1 = 283 
-         ij0 = 201 + isrow   ;   ij1 = 241 - isrow
-         tg_fmask%d_value(ii0:ii1,ij0:ij1,1:jpk,1) = 2._dp  
-
-         ! Bhosporus Strait
-         ii0 = 314           ;   ii1 = 315
-         ij0 = 208 + isrow   ;   ij1 = 248 - isrow 
-         tg_fmask%d_value(ii0:ii1,ij0:ij1,1:jpk,1 ) = 2._dp  
-
-         ! Makassar Strait (Top) 
-         ii0 =  48           ;   ii1 =  48
-         ij0 = 149 + isrow   ;   ij1 = 190 - isrow
-         tg_fmask%d_value(ii0:ii1,ij0:ij1,1:jpk,1 ) = 3._dp  
-
-         ! Lombok Strait
-         ii0 =  44           ;   ii1 =  44
-         ij0 = 124 + isrow   ;   ij1 = 165 - isrow
-         tg_fmask%d_value(ii0:ii1,ij0:ij1,1:jpk,1 ) = 2._dp  
-
-         ! Ombai Strait
-         ii0 =  53           ;   ii1 =  53
-         ij0 = 124 + isrow   ;   ij1 = 165 - isrow
-         tg_fmask%d_value(ii0:ii1,ij0:ij1,1:jpk,1 ) = 2._dp  
-
-         ! Timor Passage
-         ii0 =  56           ;   ii1 =  56
-         ij0 = 124 + isrow   ;   ij1 = 165 - isrow
-         tg_fmask%d_value(ii0:ii1,ij0:ij1,1:jpk,1 ) = 2._dp  
-
-         ! West Halmahera Strait
-         ii0 =  58           ;   ii1 =  58
-         ij0 = 141 + isrow   ;   ij1 = 182 - isrow
-         tg_fmask%d_value(ii0:ii1,ij0:ij1,1:jpk,1 ) = 3._dp  
-
-         ! East Halmahera Strait
-         ii0 =  55           ;   ii1 =  55
-         ij0 = 141 + isrow   ;   ij1 = 182 - isrow
-         tg_fmask%d_value(ii0:ii1,ij0:ij1,1:jpk,1 ) = 3._dp  
-         !
-      ENDIF
+      DEALLOCATE( zwf )
+
+!      IF( td_nam%c_cfg == "orca" .AND. td_nam%i_cfg == 2 )THEN   ! ORCA_R2 configuration
+!         !                                                 ! Increased lateral friction near of some straits
+!         IF( td_nam%i_cla == 0 ) THEN
+!            ! Gibraltar strait  : partial slip (fmask=0.5)
+!            ij0 = 101   ;   ij1 = 101
+!            ii0 = 139   ;   ii1 = 140   
+!            tg_fmask%d_value(ii0:ii1,ij0:ij1,1:jpk,1) =  0.5_dp
+!
+!            ij0 = 102   ;   ij1 = 102
+!            ii0 = 139   ;   ii1 = 140
+!            tg_fmask%d_value(ii0:ii1,ij0:ij1,1:jpk,1) =  0.5_dp
+!            !
+!            !Bab el Mandeb : partial slip (fmask=1)
+!            ij0 =  87   ;   ij1 =  88
+!            ii0 = 160   ;   ii1 = 160
+!            tg_fmask%d_value(ii0:ii1,ij0:ij1,1:jpk,1) =  1._dp
+!
+!            ij0 =  88   ;   ij1 =  88
+!            ii0 = 159   ;   ii1 = 159
+!            tg_fmask%d_value(ii0:ii1,ij0:ij1,1:jpk,1) =  1._dp
+!            !
+!         ENDIF
+!      ENDIF
+!      !
+!      IF( td_nam%c_cfg == "orca" .AND. td_nam%i_cfg == 1 )THEN   ! ORCA R1 configuration
+!         ! Increased lateral friction near of some straits
+!         ! This dirty section will be suppressed by simplification process:
+!         ! all this will come back in input files
+!         ! Currently these hard-wired indices relate to configuration with
+!         ! extend grid (jpjglo=332)
+!         !
+!         isrow = 332 - jpj
+!         ! Gibraltar Strait
+!         ii0 = 282           ;   ii1 = 283 
+!         ij0 = 201 + isrow   ;   ij1 = 241 - isrow
+!         tg_fmask%d_value(ii0:ii1,ij0:ij1,1:jpk,1) = 2._dp  
+!
+!         ! Bhosporus Strait
+!         ii0 = 314           ;   ii1 = 315
+!         ij0 = 208 + isrow   ;   ij1 = 248 - isrow 
+!         tg_fmask%d_value(ii0:ii1,ij0:ij1,1:jpk,1 ) = 2._dp  
+!
+!         ! Makassar Strait (Top) 
+!         ii0 =  48           ;   ii1 =  48
+!         ij0 = 149 + isrow   ;   ij1 = 190 - isrow
+!         tg_fmask%d_value(ii0:ii1,ij0:ij1,1:jpk,1 ) = 3._dp  
+!
+!         ! Lombok Strait
+!         ii0 =  44           ;   ii1 =  44
+!         ij0 = 124 + isrow   ;   ij1 = 165 - isrow
+!         tg_fmask%d_value(ii0:ii1,ij0:ij1,1:jpk,1 ) = 2._dp  
+!
+!         ! Ombai Strait
+!         ii0 =  53           ;   ii1 =  53
+!         ij0 = 124 + isrow   ;   ij1 = 165 - isrow
+!         tg_fmask%d_value(ii0:ii1,ij0:ij1,1:jpk,1 ) = 2._dp  
+!
+!         ! Timor Passage
+!         ii0 =  56           ;   ii1 =  56
+!         ij0 = 124 + isrow   ;   ij1 = 165 - isrow
+!         tg_fmask%d_value(ii0:ii1,ij0:ij1,1:jpk,1 ) = 2._dp  
+!
+!         ! West Halmahera Strait
+!         ii0 =  58           ;   ii1 =  58
+!         ij0 = 141 + isrow   ;   ij1 = 182 - isrow
+!         tg_fmask%d_value(ii0:ii1,ij0:ij1,1:jpk,1 ) = 3._dp  
+!
+!         ! East Halmahera Strait
+!         ii0 =  55           ;   ii1 =  55
+!         ij0 = 141 + isrow   ;   ij1 = 182 - isrow
+!         tg_fmask%d_value(ii0:ii1,ij0:ij1,1:jpk,1 ) = 3._dp  
+!         !
+!      ENDIF
       !
       CALL lbc_lnk( tg_fmask%d_value(:,:,:,1), 'F', td_nam%i_perio, 1._dp )      ! Lateral boundary conditions on fmask
 
 !      DEALLOCATE( imsk )
-      DEALLOCATE( zwf )
+      ENDIF ! ld_domcfg
 
 !      DEALLOCATE( dl_tpol )
Index: branches/2016/dev_r6999_CONFIGMAN_1/NEMOGCM/TOOLS/SIREN/src/create_restart.f90
===================================================================
--- branches/2016/dev_r6999_CONFIGMAN_1/NEMOGCM/TOOLS/SIREN/src/create_restart.f90	(revision 7148)
+++ branches/2016/dev_r6999_CONFIGMAN_1/NEMOGCM/TOOLS/SIREN/src/create_restart.f90	(revision 7153)
@@ -48,4 +48,6 @@
 !>       - cn_varcfg : variable configuration file
 !> (see ./SIREN/cfg/variable.cfg)
+!>       - cn_dimcfg : dimension configuration file. define dimension allowed to
+!> be used (see ./SIREN/cfg/dimension.cfg).
 !>       - cn_dumcfg : useless (dummy) configuration file, for useless 
 !> dimension or variable (see ./SIREN/cfg/dummy.cfg).
@@ -160,4 +162,6 @@
 !> @date September, 2015
 !> - manage useless (dummy) variable, attributes, and dimension
+!> @date October, 2016
+!> - dimension to be used select from configuration file
 !>
 !> @todo
@@ -201,6 +205,6 @@
    INTEGER(i4)                                        :: il_status
    INTEGER(i4)                                        :: il_fileid
+   INTEGER(i4)                                        :: il_attid
    INTEGER(i4)                                        :: il_nvar
-   INTEGER(i4)                                        :: il_attid
    INTEGER(i4)                                        :: il_imin1
    INTEGER(i4)                                        :: il_imax1
@@ -254,6 +258,7 @@
 
    ! namcfg
-   CHARACTER(LEN=lc)                       :: cn_varcfg = 'variable.cfg' 
-   CHARACTER(LEN=lc)                       :: cn_dumcfg = 'dummy.cfg'
+   CHARACTER(LEN=lc)                       :: cn_varcfg = './cfg/variable.cfg' 
+   CHARACTER(LEN=lc)                       :: cn_dimcfg = './cfg/dimension.cfg'
+   CHARACTER(LEN=lc)                       :: cn_dumcfg = './cfg/dummy.cfg'
 
    ! namcrs
@@ -308,4 +313,5 @@
    NAMELIST /namcfg/ &  !< configuration namelist
    &  cn_varcfg, &      !< variable configuration file
+   &  cn_dimcfg, &      !< dimension configuration file
    &  cn_dumcfg         !< dummy configuration file
 
@@ -313,5 +319,5 @@
    &  cn_coord0,  &     !< coordinate file
    &  in_perio0         !< periodicity index
-   
+
    NAMELIST /namfin/ &  !< fine grid namelist
    &  cn_coord1,   &    !< coordinate file
@@ -339,5 +345,5 @@
    &  cn_varfile, &     !< list of variable file
    &  cn_varinfo        !< list of variable and interpolation method to be used.
-   
+
    NAMELIST /namnst/ &  !< nesting namelist
    &  in_rhoi,    &     !< refinement factor in i-direction
@@ -389,4 +395,7 @@
       ! get variable extra information
       CALL var_def_extra(TRIM(cn_varcfg))
+
+      ! get dimension allowed
+      CALL dim_def_extra(TRIM(cn_dimcfg))
 
       ! get dummy variable
@@ -900,4 +909,5 @@
    CALL mpp_clean(tl_mppout)
    CALL mpp_clean(tl_coord1)
+   CALL var_clean_extra()
 
    ! close log file
@@ -1204,5 +1214,5 @@
             &        tl_depth%d_value(:,:,:,:) ) )THEN
 
-               CALL logger_warn("CREATE BOUNDARY: depth value from "//&
+               CALL logger_warn("CREATE RESTART: depth value from "//&
                &  TRIM(td_mpp%c_name)//" not conform "//&
                &  " to those from former file(s).")
Index: branches/2016/dev_r6999_CONFIGMAN_1/NEMOGCM/TOOLS/SIREN/src/dimension.f90
===================================================================
--- branches/2016/dev_r6999_CONFIGMAN_1/NEMOGCM/TOOLS/SIREN/src/dimension.f90	(revision 7148)
+++ branches/2016/dev_r6999_CONFIGMAN_1/NEMOGCM/TOOLS/SIREN/src/dimension.f90	(revision 7153)
@@ -156,4 +156,6 @@
 !> @date Spetember, 2015
 !> - manage useless (dummy) dimension
+!> @date October, 2016
+!> - dimension allowed read in configuration file
 !>
 !> @note Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
@@ -171,4 +173,8 @@
 
    PRIVATE :: cm_dumdim        !< dummy dimension array
+   PRIVATE :: cm_dimX          !< x dimension array
+   PRIVATE :: cm_dimY          !< y dimension array
+   PRIVATE :: cm_dimZ          !< z dimension array
+   PRIVATE :: cm_dimT          !< t dimension array
 
    ! function and subroutine
@@ -188,4 +194,5 @@
    PUBLIC :: dim_get_dummy     !< fill dummy dimension array
    PUBLIC :: dim_is_dummy      !< check if dimension is defined as dummy dimension
+   PUBLIC :: dim_def_extra     !< read dimension configuration file, and save dimension allowed.
 
    PRIVATE :: dim__reshape_2xyzt_dp ! reshape real(8) 4D array to ('x','y','z','t')
@@ -203,4 +210,5 @@
    PRIVATE :: dim__copy_unit        ! copy dimension structure
    PRIVATE :: dim__copy_arr         ! copy array of dimension structure
+   PRIVATE :: dim__is_allowed
 
    TYPE TDIM !< dimension structure
@@ -215,5 +223,9 @@
    END TYPE
 
-   CHARACTER(LEN=lc), DIMENSION(ip_maxdum), SAVE :: cm_dumdim !< dummy dimension
+   CHARACTER(LEN=lc), DIMENSION(ip_maxdumcfg), SAVE :: cm_dumdim !< dummy dimension
+   CHARACTER(LEN=lc), DIMENSION(ip_maxdimcfg), SAVE :: cm_dimX   !< x dimension
+   CHARACTER(LEN=lc), DIMENSION(ip_maxdimcfg), SAVE :: cm_dimY   !< y dimension
+   CHARACTER(LEN=lc), DIMENSION(ip_maxdimcfg), SAVE :: cm_dimZ   !< z dimension
+   CHARACTER(LEN=lc), DIMENSION(ip_maxdimcfg), SAVE :: cm_dimT   !< t dimension
 
    INTERFACE dim_print
@@ -587,15 +599,16 @@
          cl_name=fct_lower(cd_name)
 
-         IF( TRIM(cl_name) == 'x' )THEN
+         IF(     dim__is_allowed(TRIM(cl_name), cm_dimX(:)) )THEN
             dim_init%c_sname='x'
-         ELSEIF( TRIM(cl_name) == 'y' )THEN
+         ELSEIF( dim__is_allowed(TRIM(cl_name), cm_dimY(:)) )THEN
             dim_init%c_sname='y'
-         ELSEIF( TRIM(cl_name)== 'z' .OR. &
-         &       INDEX(cl_name,'depth')/=0 )THEN
+         ELSEIF( dim__is_allowed(TRIM(cl_name), cm_dimZ(:)) )THEN
             dim_init%c_sname='z'
-         ELSEIF( TRIM(cl_name)== 't' .OR. &
-         &       INDEX(cl_name,'time')/=0 )THEN
+         ELSEIF( dim__is_allowed(TRIM(cl_name), cm_dimT(:)) )THEN
             dim_init%c_sname='t'
-         ENDIF      
+         ELSE
+            CALL logger_warn("DIM INIT: "//TRIM(cd_name)//&
+            " not allowed.")
+         ENDIF
 
       ENDIF
@@ -1430,7 +1443,7 @@
       ! loop indices
       ! namelist
-      CHARACTER(LEN=lc), DIMENSION(ip_maxdum) :: cn_dumvar
-      CHARACTER(LEN=lc), DIMENSION(ip_maxdum) :: cn_dumdim
-      CHARACTER(LEN=lc), DIMENSION(ip_maxdum) :: cn_dumatt
+      CHARACTER(LEN=lc), DIMENSION(ip_maxdumcfg) :: cn_dumvar
+      CHARACTER(LEN=lc), DIMENSION(ip_maxdumcfg) :: cn_dumdim
+      CHARACTER(LEN=lc), DIMENSION(ip_maxdumcfg) :: cn_dumatt
 
       !----------------------------------------------------------------
@@ -1493,5 +1506,5 @@
 
       dim_is_dummy=.FALSE.
-      DO ji=1,ip_maxdum
+      DO ji=1,ip_maxdumcfg
          IF( fct_lower(td_dim%c_name) == fct_lower(cm_dumdim(ji)) )THEN
             dim_is_dummy=.TRUE.
@@ -1501,4 +1514,117 @@
 
    END FUNCTION dim_is_dummy
+   !-------------------------------------------------------------------
+   !> @brief This subroutine read dimension configuration file, 
+   !> and fill array of dimension allowed.
+   !>
+   !> @author J.Paul
+   !> @date Ocotber, 2016 - Initial Version
+   !
+   !> @param[in] cd_file input file (dimension configuration file)
+   !-------------------------------------------------------------------
+   SUBROUTINE dim_def_extra( cd_file )
+      IMPLICIT NONE
+
+      ! Argument      
+      CHARACTER(LEN=*), INTENT(IN) :: cd_file
+
+      ! local variable
+      INTEGER(i4)   :: il_fileid
+      INTEGER(i4)   :: il_status
+
+      LOGICAL       :: ll_exist
+      
+      ! loop indices
+      ! namelist
+      CHARACTER(LEN=lc), DIMENSION(ip_maxdimcfg) :: cn_dimX = '' 
+      CHARACTER(LEN=lc), DIMENSION(ip_maxdimcfg) :: cn_dimY = ''
+      CHARACTER(LEN=lc), DIMENSION(ip_maxdimcfg) :: cn_dimZ = ''
+      CHARACTER(LEN=lc), DIMENSION(ip_maxdimcfg) :: cn_dimT = ''
+
+      !----------------------------------------------------------------
+      NAMELIST /namdim/ &   !< dimension namelist
+      &  cn_dimX, &       !< x dimension name allowed
+      &  cn_dimY, &       !< y dimension name allowed
+      &  cn_dimZ, &       !< z dimension name allowed
+      &  cn_dimT          !< t dimension name allowed
+
+      !----------------------------------------------------------------
+
+      ! init
+      cm_dimX(:)=''
+      cm_dimY(:)=''
+      cm_dimZ(:)=''
+      cm_dimT(:)=''
+
+      ! read config variable file
+      INQUIRE(FILE=TRIM(cd_file), EXIST=ll_exist)
+      IF( ll_exist )THEN
+
+         il_fileid=fct_getunit()
+   
+         OPEN( il_fileid, FILE=TRIM(cd_file), &
+         &                FORM='FORMATTED',       &
+         &                ACCESS='SEQUENTIAL',    &
+         &                STATUS='OLD',           &
+         &                ACTION='READ',          &
+         &                IOSTAT=il_status)
+         CALL fct_err(il_status)
+         IF( il_status /= 0 )THEN
+            CALL logger_fatal("DIM GET DUMMY: opening "//TRIM(cd_file))
+         ENDIF
+   
+         READ( il_fileid, NML = namdim )
+         cm_dimX(:)=cn_dimX(:)
+         cm_dimY(:)=cn_dimY(:)
+         cm_dimZ(:)=cn_dimZ(:)
+         cm_dimT(:)=cn_dimT(:)
+
+         CLOSE( il_fileid )
+
+      ELSE
+
+         CALL logger_fatal("DIM DEF EXTRA: can't find configuration"//&
+            &              " file "//TRIM(cd_file))
+
+      ENDIF         
+
+   END SUBROUTINE dim_def_extra
+   !-------------------------------------------------------------------
+   !> @brief This function check if dimension is allowed, i.e defined 
+   !> in dimension configuraton file
+   !>
+   !> @author J.Paul
+   !> @date OCTOber, 2016 - Initial Version
+   !
+   !> @param[in] cd_name dimension name
+   !> @param[in] cd_dim  array dimension name allowed
+   !> @return true if dimension is allowed 
+   !-------------------------------------------------------------------
+   FUNCTION dim__is_allowed(cd_name, cd_dim)
+      IMPLICIT NONE
+
+      ! Argument
+      CHARACTER(LEN=*),               INTENT(IN) :: cd_name
+      CHARACTER(LEN=*), DIMENSION(:), INTENT(IN) :: cd_dim
+      
+      ! function
+      LOGICAL :: dim__is_allowed
+      
+      ! loop indices
+      INTEGER(i4) :: ji
+      !----------------------------------------------------------------
+
+      dim__is_allowed=.FALSE.
+      ji=1
+      DO WHILE( TRIM(cd_dim(ji)) /= '' )
+         IF( TRIM(fct_lower(cd_name)) == TRIM(fct_lower(cd_dim(ji))) )THEN
+            dim__is_allowed=.TRUE.
+            EXIT
+         ENDIF
+         ji=ji+1
+      ENDDO
+
+   END FUNCTION dim__is_allowed
+
 END MODULE dim
 
Index: branches/2016/dev_r6999_CONFIGMAN_1/NEMOGCM/TOOLS/SIREN/src/global.f90
===================================================================
--- branches/2016/dev_r6999_CONFIGMAN_1/NEMOGCM/TOOLS/SIREN/src/global.f90	(revision 7148)
+++ branches/2016/dev_r6999_CONFIGMAN_1/NEMOGCM/TOOLS/SIREN/src/global.f90	(revision 7153)
@@ -67,6 +67,6 @@
 
    INTEGER(i4)                             , PARAMETER :: ip_maxvar =200   !< maximum number of variable
-   INTEGER(i4)                             , PARAMETER :: ip_maxmtx =100   !< matrix variable maximum dimension (cf create_bathy)
-   INTEGER(i4)                             , PARAMETER :: ip_maxseg =50    !< maximum number of segment for each boundary
+   INTEGER(i4)                             , PARAMETER :: ip_maxmtx =50    !< matrix variable maximum dimension (cf create_bathy)
+   INTEGER(i4)                             , PARAMETER :: ip_maxseg =10    !< maximum number of segment for each boundary
 
    INTEGER(i4)                             , PARAMETER :: ip_nsep=2        !< number of separator listed
@@ -112,4 +112,5 @@
 
 
+   INTEGER(i4)                             , PARAMETER :: ip_maxdimcfg=10 !< maximum allowed dimension in configuration file
    INTEGER(i4)                             , PARAMETER :: ip_maxdim=4
    INTEGER(i4)                             , PARAMETER :: jp_I=1
@@ -131,5 +132,6 @@
    INTEGER(i4), PARAMETER :: jp_west =4
 
-   INTEGER(i4)                             , PARAMETER :: ip_maxdum = 10 !< maximum dummy variable, dimension, attribute
+   INTEGER(i4)                             , PARAMETER :: ip_maxdumcfg = 10 !< maximum dummy variable, dimension, or attribute 
+                                                                            !< in configuration file
 
 END MODULE global
Index: branches/2016/dev_r6999_CONFIGMAN_1/NEMOGCM/TOOLS/SIREN/src/grid.f90
===================================================================
--- branches/2016/dev_r6999_CONFIGMAN_1/NEMOGCM/TOOLS/SIREN/src/grid.f90	(revision 7148)
+++ branches/2016/dev_r6999_CONFIGMAN_1/NEMOGCM/TOOLS/SIREN/src/grid.f90	(revision 7153)
@@ -478,5 +478,5 @@
    !-------------------------------------------------------------------
    !> @brief This subroutine get information about global domain, given mpp
-   !> strucutre.
+   !> structure.
    !>
    !> @details
@@ -547,10 +547,10 @@
 
       SELECT CASE(il_perio)
-      CASE(3,4)
-         il_pivot=1
-      CASE(5,6)
-         il_pivot=0
-      CASE(0,1,2)
-         il_pivot=1
+         CASE(3,4)
+            il_pivot=1
+         CASE(5,6)
+            il_pivot=0
+         CASE(0,1,2)
+            il_pivot=1
       END SELECT
 
@@ -1668,5 +1668,5 @@
    !> else return the size of the ovarlap band.
    !> East-West overlap is computed comparing longitude value of the  
-   !> South" part of the domain, to avoid  north fold boundary.
+   !> South part of the domain, to avoid  north fold boundary.
    !>
    !
@@ -1675,4 +1675,6 @@
    !> @date October, 2014
    !> - work on mpp file structure instead of file structure
+   !> @date October, 2016
+   !> - check longitude as longname
    !>
    !> @param[in] td_lon longitude variable structure 
@@ -1724,12 +1726,13 @@
             ALLOCATE( dl_vare(il_jmax-il_jmin+1) )
             ALLOCATE( dl_varw(il_jmax-il_jmin+1) )
-            
+
             dl_vare(:)=dl_value(il_east,il_jmin:il_jmax)
             dl_varw(:)=dl_value(il_west,il_jmin:il_jmax)
-            
-            IF( .NOT.(  ALL(dl_vare(:)==td_var%d_fill) .AND. &
-            &           ALL(dl_varw(:)==td_var%d_fill) ) )THEN
-         
-               IF( TRIM(td_var%c_stdname) == 'longitude' )THEN
+
+            IF( .NOT.( ALL(dl_vare(:)==td_var%d_fill) .AND. &
+            &          ALL(dl_varw(:)==td_var%d_fill) ) )THEN
+
+               IF( TRIM(td_var%c_stdname) == 'longitude' .OR. &
+                 & SCAN(TRIM(td_var%c_longname), 'longitude') == 0 )THEN
                   WHERE( dl_value(:,:) > 180._dp .AND. &
                   &      dl_value(:,:) /= td_var%d_fill ) 
@@ -1755,5 +1758,5 @@
                      ELSE
                         dl_vare(:)=dl_value(il_east-ji,il_jmin:il_jmax)
-                        
+
                         IF( ALL( dl_varw(:) == dl_vare(:) ) )THEN
                            grid__get_ew_overlap_var=ji+1
@@ -1781,8 +1784,10 @@
    !> else return the size of the ovarlap band.
    !> East-West overlap is computed comparing longitude value of the  
-   !> South" part of the domain, to avoid  north fold boundary.
+   !> South part of the domain, to avoid  north fold boundary.
    !>
    !> @author J.Paul
    !> @date October, 2014 - Initial Version
+   !> @date October, 2016
+   !> - check varid for longitude_T
    !>
    !> @param[in] td_file file structure 
@@ -1805,8 +1810,8 @@
       !----------------------------------------------------------------
 
-      il_varid=var_get_index(td_file%t_var(:), 'longitude')
+      il_varid=var_get_id(td_file%t_var(:), 'longitude', 'longitude_T')
       IF( il_varid /= 0 )THEN
          ! read longitude on boundary
-         tl_var=iom_read_var(td_file, 'longitude')
+         tl_var=iom_read_var(td_file, il_varid)
       ELSE
          DO ji=1,td_file%i_nvar
@@ -1831,5 +1836,5 @@
    !> else return the size of the ovarlap band.
    !> East-West overlap is computed comparing longitude value of the  
-   !> South" part of the domain, to avoid  north fold boundary.
+   !> South part of the domain, to avoid  north fold boundary.
    !>
    !
@@ -1838,4 +1843,6 @@
    !> @date October, 2014
    !> - work on mpp file structure instead of file structure
+   !> @date October, 2016
+   !> - check varid for longitude_T
    !>
    !> @param[in] td_mpp mpp structure 
@@ -1862,7 +1869,7 @@
 
       ! read longitude on boundary
-      il_varid=var_get_index(td_mpp%t_proc(1)%t_var(:),'longitude')
+      il_varid=var_get_id(td_mpp%t_proc(1)%t_var(:),'longitude', 'longitude_T')
       IF( il_varid /= 0 )THEN
-         tl_var=iom_mpp_read_var(td_mpp, 'longitude')
+         tl_var=iom_mpp_read_var(td_mpp, il_varid)
       ELSE
          DO ji=1,td_mpp%t_proc(1)%i_nvar
@@ -1878,5 +1885,4 @@
          grid__get_ew_overlap_mpp=il_ew
       ENDIF
-
 
       ! clean
@@ -3033,5 +3039,7 @@
    !> @author J.Paul
    !> @date April, 2016 - Initial Version
-   !
+   !> @date October, 2016
+   !> - use max of zero and east-west overlap instead of east-west overlap
+   !>
    !> @param[in] td_coord0 coarse grid coordinate mpp structure
    !> @param[in] dd_lon1   fine   grid longitude
@@ -3060,4 +3068,5 @@
 
       INTEGER(i4)                              :: il_ind
+      INTEGER(i4)                              :: il_ew
 
       REAL(dp)   , DIMENSION(:,:), ALLOCATABLE :: dl_lon0
@@ -3109,11 +3118,12 @@
          CALL iom_mpp_close(tl_coord0)
 
-         ALLOCATE(dl_lon0(tl_coord0%t_dim(jp_I)%i_len-tl_coord0%i_ew, &
+         il_ew=MAX(0,tl_coord0%i_ew)
+         ALLOCATE(dl_lon0(tl_coord0%t_dim(jp_I)%i_len-il_ew, &
             &             tl_coord0%t_dim(jp_J)%i_len) )             
-         ALLOCATE(dl_lat0(tl_coord0%t_dim(jp_I)%i_len-tl_coord0%i_ew, &
+         ALLOCATE(dl_lat0(tl_coord0%t_dim(jp_I)%i_len-il_ew, &
             &             tl_coord0%t_dim(jp_J)%i_len) )
 
-         dl_lon0(:,:)=tl_lon0%d_value(tl_coord0%i_ew+1:,:,1,1)
-         dl_lat0(:,:)=tl_lat0%d_value(tl_coord0%i_ew+1:,:,1,1)
+         dl_lon0(:,:)=tl_lon0%d_value(il_ew+1:,:,1,1)
+         dl_lat0(:,:)=tl_lat0%d_value(il_ew+1:,:,1,1)
 
          id_res(:)=grid_get_closest( dl_lon0, dl_lat0, dd_lon1, dd_lat1, cd_pos, dd_fill )
@@ -3602,5 +3612,5 @@
          ENDIF
          tl_lat0=iom_mpp_read_var(tl_coord0, TRIM(cl_name))
-         
+
          ! close mpp files
          CALL iom_mpp_close(tl_coord0)
